# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Classes

* [`device_manager::conf`](#device_managerconf)
* [`device_manager::devices`](#device_managerdevices)
* [`device_manager::fact`](#device_managerfact)
* [`device_manager::run`](#device_managerrun)
* [`device_manager::run::via_cron::untargeted`](#device_managerrunvia_cronuntargeted)
* [`device_manager::run::via_exec::untargeted`](#device_managerrunvia_execuntargeted)
* [`device_manager::run::via_scheduled_task::untargeted`](#device_managerrunvia_scheduled_taskuntargeted)

### Defined types

* [`device_manager`](#device_manager)
* [`device_manager::conf::device`](#device_managerconfdevice)
* [`device_manager::fact::device`](#device_managerfactdevice)
* [`device_manager::run::via_cron::device`](#device_managerrunvia_crondevice)
* [`device_manager::run::via_exec::device`](#device_managerrunvia_execdevice)
* [`device_manager::run::via_scheduled_task::device`](#device_managerrunvia_scheduled_taskdevice)

### Functions

* [`device_manager::interval_to_cron_time`](#device_managerinterval_to_cron_time)

### Tasks

* [`run_puppet_device`](#run_puppet_device): Run puppet device on a (proxy) Puppet agent

## Classes

### <a name="device_managerconf"></a>`device_manager::conf`

The device_manager::conf class.

### <a name="device_managerdevices"></a>`device_manager::devices`

The device_manager::devices class.

#### Parameters

The following parameters are available in the `device_manager::devices` class:

* [`devices`](#devices)
* [`defaults`](#defaults)

##### <a name="devices"></a>`devices`

Data type: `Hash`



Default value: `{}`

##### <a name="defaults"></a>`defaults`

Data type: `Hash`



Default value: `{}`

### <a name="device_managerfact"></a>`device_manager::fact`

The device_manager::fact class.

### <a name="device_managerrun"></a>`device_manager::run`

The device_manager::run class.

### <a name="device_managerrunvia_cronuntargeted"></a>`device_manager::run::via_cron::untargeted`

The device_manager::run::via_cron::untargeted class.

### <a name="device_managerrunvia_execuntargeted"></a>`device_manager::run::via_exec::untargeted`

The device_manager::run::via_exec::untargeted class.

### <a name="device_managerrunvia_scheduled_taskuntargeted"></a>`device_manager::run::via_scheduled_task::untargeted`

The device_manager::run::via_scheduled_task::untargeted class.

## Defined types

### <a name="device_manager"></a>`device_manager`

The device_manager class.

#### Parameters

The following parameters are available in the `device_manager` defined type:

* [`type`](#type)
* [`url`](#url)
* [`credentials`](#credentials)
* [`debug`](#debug)
* [`run_interval`](#run_interval)
* [`run_via_exec`](#run_via_exec)
* [`run_user`](#run_user)
* [`run_group`](#run_group)
* [`include_module`](#include_module)
* [`ensure`](#ensure)

##### <a name="type"></a>`type`

Data type: `String[1]`



##### <a name="url"></a>`url`

Data type: `String`



Default value: `''`

##### <a name="credentials"></a>`credentials`

Data type: `Hash`



Default value: `{}`

##### <a name="debug"></a>`debug`

Data type: `Boolean`



Default value: ``false``

##### <a name="run_interval"></a>`run_interval`

Data type: `Integer[0,1440]`



Default value: `0`

##### <a name="run_via_exec"></a>`run_via_exec`

Data type: `Boolean`



Default value: ``false``

##### <a name="run_user"></a>`run_user`

Data type: `String`



Default value: `$::identity['user']`

##### <a name="run_group"></a>`run_group`

Data type: `String`



Default value: `$::identity['group']`

##### <a name="include_module"></a>`include_module`

Data type: `Boolean`



Default value: ``true``

##### <a name="ensure"></a>`ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### <a name="device_managerconfdevice"></a>`device_manager::conf::device`

The device_manager::conf::device class.

#### Parameters

The following parameters are available in the `device_manager::conf::device` defined type:

* [`type`](#type)
* [`url`](#url)
* [`credentials`](#credentials)
* [`run_user`](#run_user)
* [`run_group`](#run_group)
* [`debug`](#debug)
* [`ensure`](#ensure)

##### <a name="type"></a>`type`

Data type: `String`



##### <a name="url"></a>`url`

Data type: `String`



##### <a name="credentials"></a>`credentials`

Data type: `Hash`



##### <a name="run_user"></a>`run_user`

Data type: `String`



##### <a name="run_group"></a>`run_group`

Data type: `String`



##### <a name="debug"></a>`debug`

Data type: `Boolean`



Default value: ``false``

##### <a name="ensure"></a>`ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### <a name="device_managerfactdevice"></a>`device_manager::fact::device`

The device_manager::fact::device class.

#### Parameters

The following parameters are available in the `device_manager::fact::device` defined type:

* [`ensure`](#ensure)

##### <a name="ensure"></a>`ensure`

Data type: `Enum[present, absent]`



Default value: `present`

### <a name="device_managerrunvia_crondevice"></a>`device_manager::run::via_cron::device`

The device_manager::run::via_cron::device class.

#### Parameters

The following parameters are available in the `device_manager::run::via_cron::device` defined type:

* [`ensure`](#ensure)
* [`run_interval`](#run_interval)
* [`run_user`](#run_user)

##### <a name="ensure"></a>`ensure`

Data type: `String`



##### <a name="run_interval"></a>`run_interval`

Data type: `Integer`



##### <a name="run_user"></a>`run_user`

Data type: `String`



### <a name="device_managerrunvia_execdevice"></a>`device_manager::run::via_exec::device`

The device_manager::run::via_exec::device class.

### <a name="device_managerrunvia_scheduled_taskdevice"></a>`device_manager::run::via_scheduled_task::device`

The device_manager::run::via_scheduled_task::device class.

#### Parameters

The following parameters are available in the `device_manager::run::via_scheduled_task::device` defined type:

* [`ensure`](#ensure)
* [`run_interval`](#run_interval)
* [`run_user`](#run_user)

##### <a name="ensure"></a>`ensure`

Data type: `String`



##### <a name="run_interval"></a>`run_interval`

Data type: `Integer`



##### <a name="run_user"></a>`run_user`

Data type: `String`



## Functions

### <a name="device_managerinterval_to_cron_time"></a>`device_manager::interval_to_cron_time`

Type: Puppet Language

The device_manager::interval_to_cron_time function.

#### `device_manager::interval_to_cron_time(Integer[0,1440] $interval, Integer[0,59] $offset)`

The device_manager::interval_to_cron_time function.

Returns: `Hash`

##### `interval`

Data type: `Integer[0,1440]`



##### `offset`

Data type: `Integer[0,59]`



## Tasks

### <a name="run_puppet_device"></a>`run_puppet_device`

Run puppet device on a (proxy) Puppet agent

**Supports noop?** true

#### Parameters

##### `target`

Data type: `Optional[Pattern[/^[a-z0-9._-]+$/]]`

The name of a device in device.conf on the (proxy) Puppet agent

##### `timeout`

Data type: `Optional[Variant[Integer, Pattern[/^[0-9]+$/]]]`

The timeout in seconds for the puppet device command(s), defaults to 64

